      subroutine subg(xx,a,yfit,dyda,nfit) ! bernd berg, mar 12 2015.
c Correction of dyda(1) on Apr 28 2016: a(1) was a(2).
c User provided subroutine for the fit function y=a4*xx**a1*(1+a2*xx**a3).
c Particular application: 4 paramter fit for critical exponents.
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      dimension a(nfit),dyda(nfit)
      if(nfit.ne.4) stop "subg_power2n.f: nfit.ne.4."
      x4=xx**a(3)
      a3x4=a(2)*x4
      x2=xx**a(1)
      yy=x2*(one+a3x4)
      yfit=a(4)*yy
      xln=log(xx)
      dyda(1)=a(4)*xln*xx**a(1)*(one+a3x4) ! Correction on 4/28/16.
      dyda(2)=a(4)*x2*x4
      dyda(3)=a(4)*x2*xln*a3x4
      dyda(4)=yy
      return
      end
