      subroutine chi2c0n0(n,x,y,ye,c0,c0e,chi2) ! bb may 20 2015.
c Determination of normalization constant c0 and chi2 for chi2 fit of 
c data y_i with fit function c0*f. 
c Input: data arrays x(n),y(n),ye(n), 
c Output: c0, c0e, chi2.
c        variable fit parameters a(nf).
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      dimension x(n),y(n),ye(n)
      ltest=.true.
      ltest=.false.
      if(ltest) stop "chi2c0: ltest."
      r=zero
      s=zero
      c0e=zero
      do i=1,n
        call suby(x(i),f)
        ye2i=one/ye(i)**2 ! Inverse errorbar squared.
        ri=f*ye2i
        r=r+y(i)*ri           ! iterate r.
        s=s+f*ri              ! iterate s.
        c0e=c0e+(ri*ye(i))**2 ! iterate for c0e.
      enddo
      c0=r/s
      c0e=sqrt(c0e/s**2)
      chi2=zero
      do i=1,n
        call subg(x(i),c0,yfit,dyda,ione)
        chi2=chi2+((y(i)-yfit)/ye(i))**2
      enddo
      return
      end
