      subroutine suby(x,a,y,dyda,nfit) ! bb may 20 2015.
c User provided fit function y=(1+a1/x)/flasu2(x,2) and its derivative 
c dyda for fit yfit=a2*y, where the normalization a2 is calculated in 
c subgfitm1 by the chi2dcda subroutine. Here yfit is a 2-parameter fit 
c of the pure su2 scale with x=beta and flasu2(x,2) the asymptotic 
c scaling function (yfit has the dimension of a length).
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      dimension a(nfit),dyda(nfit)
      if(nfit.ne.1) stop "suby_la3su2: nfit.ne.2."
      flasu2=fla(x,itwo)
      y=(one+a(1)/x)/flasu2
      dyda(1)=(one/x)/flasu2
      return
      end
